! LOGSTEP Module: dlaed2_batch.F90
!
! * This program is written by Yusuke HIROTA.
!
! # License (MIT License)
! Copyright 2018 RIKEN.
!
! Permission is hereby granted, free of charge, to any person obtaining
! a copy of this software and associated documentation files (the
! "Software"), to deal in the Software without restriction, including
! without limitation the rights to use, copy, modify, merge, publish,
! distribute, sublicense, and/or sell copies of the Software, and to
! permit persons to whom the Software is furnished to do so, subject to
! the following conditions:
!
! The above copyright notice and this permission notice shall be
! included in all copies or substantial portions of the Software.
!
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
! EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
! MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
! IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
! CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
! TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
! SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
!
subroutine dlaed2_batch(v2, batch_count, info)
  use batch_sep_dc_type
  implicit none
  type(batch_dlaed2_parameter), intent(inout) :: v2(*)
  integer, intent(in) :: batch_count
  integer, intent(out) :: info
  integer :: i
  
  info = 0

  !$omp parallel do schedule(static) if (batch_count > 64)
  do i = 1, batch_count
    call dlaed2(v2(i)%k_ptr, v2(i)%n, v2(i)%cutpnt, v2(i)%d_ptr, v2(i)%q_ptr, v2(i)%ldq, v2(i)%indxq_ptr, v2(i)%rho_ptr, &
                v2(i)%work_iz_ptr, v2(i)%work_idlmda_ptr, v2(i)%work_iw_ptr, v2(i)%work_iq2_ptr, &
                v2(i)%iwork_indx_ptr, v2(i)%iwork_indxc_ptr, v2(i)%iwork_indxp_ptr, v2(i)%iwork_coltyp_ptr, info)
  enddo
  !$omp end parallel do

  return
end

