# Only GAWK is used for test.

BEGIN {
  tol_accuracy_eigenvalue = 1.0e-04;
  tol_accuracy_relative_residual = 1.0e-10;
  tol_accuracy_relative_orthogonality = 1.0e-12;
  
  received_accuracy_eigenvalue = 0;
  received_accuracy_relative_residual = 0;
  received_accuracy_relative_orthogonality = 0;
}

{
  if ($1 == "accuracy(eigenvalue)") {
    received_accuracy_eigenvalue = 1;
    accuracy_eigenvalue = $3;
  }
  if ($1 == "accuracy(relative-residual)") {
    received_accuracy_relative_residual = 1;
    accuracy_relative_residual = $3;
  }
  if ($1 == "accuracy(relative-orthogonality)") {
    received_accuracy_relative_orthogonality = 1;
    accuracy_relative_orthogonality = $3;
  }
}

END {
  if ((! received_accuracy_eigenvalue) || \
      (! received_accuracy_relative_residual) || \
      (! received_accuracy_relative_orthogonality)) {
    printf("NG : Cannot received one or more accuracy info.\n");
  } else {
    if ((accuracy_eigenvalue >= tol_accuracy_eigenvalue) || \
        (accuracy_relative_residual >= tol_accuracy_relative_residual) || \
        (accuracy_relative_orthogonality >= tol_accuracy_relative_orthogonality)) {
      printf("NG");
    } else {
      printf("OK");
    }
    printf(" : %+.2e %+.2e %+.2e\n", \
	   accuracy_eigenvalue, accuracy_relative_residual, accuracy_relative_orthogonality);
  }
}


