BIN=driver_batch_sep_dc
AWK=awk

ulimit -s unlimited
export TEST_NUM_THREADS=228

export LD_LIBRARY_PATH="$LD_LIBRARY_PATH":/opt/intel/lib/mic
export LD_LIBRARY_PATH="$LD_LIBRARY_PATH":/opt/intel/mkl/lib/mic
export KMP_AFFINITY='compact,granularity=fine'
# This may hurt the sanity of the program.
export USE_2MB_BUFFERS=16M

# Require bash or zsh.
DUMMYSIZE=5000000
for METHOD in D P B
do
  if [ $METHOD = P ] ; then
    export OMP_NUM_THREADS=1
    export MKL_NUM_THREADS=1
  else
    export OMP_NUM_THREADS=$TEST_NUM_THREADS
    export MKL_NUM_THREADS=$TEST_NUM_THREADS
  fi
  echo METHOD = $METHOD , OMP_NUM_THREADS = $OMP_NUM_THREADS
  for MATRIX in F R M
  do
    for DIM in 2 199
    do
      for ITER in 1 2
      do
        printf "$ITER \n$DUMMYSIZE \n$MATRIX \n$DIM \n$METHOD \nT\nT\nT\n$TEST_NUM_THREADS \n" | ./$BIN | $AWK -f GNUmakefile.check.awk
      done
    done
  done
done

